uniform gl_LightSourceParameters gl_LightSource[gl_MaxLights];
uniform gl_MaterialParameters gl_FrontMaterial;
uniform gl_LightModelProducts gl_FrontLightModelProduct;

varying vec3 position;
varying vec3 normal;

void main(void)
{
    vec3 N = normalize(normal);
    vec3 L = normalize(vec3(gl_LightSource[0].position)-position);
    vec3 V = normalize(-position.xyz);
    vec3 R = reflect(-L,N);

    vec4 diffuse = vec4(max(dot(L,N),0.0));
    vec4 specular = vec4(pow(max(dot(R,V),0.0),gl_FrontMaterial.shininess));

    vec4 Iamb = gl_FrontLightProduct[0].ambient;
    vec4 Idiff = gl_FrontLightProduct[0].diffuse*diffuse;
    Idiff = clamp(Idiff, 0.0, 1.0);

    vec4 Ispec = gl_FrontLightProduct[0].specular*specular;
    Ispec = clamp(Idiff, 0.0, 1.0);

    vec4 color = /*gl_FrontLightModelProduct.sceneColor +*/ Iamb + Idiff + Ispec;

    gl_FragColor = vec4(color);
}
